diff --git a/src/share/utf8/charset.c b/src/share/utf8/charset.c
index 3e8d8ec..5a2a6e4 100644
--- a/src/share/utf8/charset.c
+++ b/src/share/utf8/charset.c
@@ -31,7 +31,7 @@
 #  include <config.h>
 #endif
 
-#ifndef HAVE_ICONV /* should be ifdef USE_CHARSET_CONVERT */
+#if !defined _WIN32 && !defined HAVE_ICONV /* should be && defined USE_CHARSET_CONVERT */
 
 #include <stdlib.h>
 
diff --git a/src/share/utf8/iconvert.c b/src/share/utf8/iconvert.c
index f76c18b..472ca87 100644
--- a/src/share/utf8/iconvert.c
+++ b/src/share/utf8/iconvert.c
@@ -20,7 +20,7 @@
 #  include <config.h>
 #endif
 
-#ifdef HAVE_ICONV
+#if !defined _WIN32 && defined HAVE_ICONV
 
 #include <assert.h>
 #include <errno.h>
diff --git a/src/share/utf8/utf8.c b/src/share/utf8/utf8.c
index fbac932..f886e32 100644
--- a/src/share/utf8/utf8.c
+++ b/src/share/utf8/utf8.c
@@ -33,7 +33,6 @@
 #include "share/alloc.h"
 #include "share/safe_str.h"
 #include "share/utf8.h"
-#include "charset.h"
 
 
 #ifdef _WIN32
@@ -247,6 +246,7 @@ int utf8_decode(const char *from, char **to)
 #endif
 
 #include "iconvert.h"
+#include "charset.h"
 
 static const char *current_charset(void)
 {
diff --git a/src/share/utf8/utf8_static.vcproj b/src/share/utf8/utf8_static.vcproj
index 9f87810..87b8ad5 100644
--- a/src/share/utf8/utf8_static.vcproj
+++ b/src/share/utf8/utf8_static.vcproj
@@ -155,18 +155,6 @@
 			Filter="h;hpp;hxx;hm;inl;inc;xsd"
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
 			>
-			<File
-				RelativePath=".\charmaps.h"
-				>
-			</File>
-			<File
-				RelativePath=".\charset.h"
-				>
-			</File>
-			<File
-				RelativePath=".\charsetmap.h"
-				>
-			</File>
 		</Filter>
 		<Filter
 			Name="Public Header Files"
@@ -182,14 +170,6 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
 			>
 			<File
-				RelativePath=".\charset.c"
-				>
-			</File>
-			<File
-				RelativePath=".\iconvert.c"
-				>
-			</File>
-			<File
 				RelativePath=".\utf8.c"
 				>
 			</File>
diff --git a/src/share/utf8/utf8_static.vcxproj b/src/share/utf8/utf8_static.vcxproj
index 53e1c1e..5298e92 100644
--- a/src/share/utf8/utf8_static.vcxproj
+++ b/src/share/utf8/utf8_static.vcxproj
@@ -130,13 +130,8 @@
   </ItemDefinitionGroup>
   <ItemGroup>
     <ClInclude Include="..\..\..\include\share\utf8.h" />
-    <ClInclude Include="charmaps.h" />
-    <ClInclude Include="charset.h" />
-    <ClInclude Include="charsetmap.h" />
   </ItemGroup>
   <ItemGroup>
-    <ClCompile Include="charset.c" />
-    <ClCompile Include="iconvert.c" />
     <ClCompile Include="utf8.c" />
   </ItemGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
diff --git a/src/share/utf8/utf8_static.vcxproj.filters b/src/share/utf8/utf8_static.vcxproj.filters
index 78ba12b..dfbaa99 100644
--- a/src/share/utf8/utf8_static.vcxproj.filters
+++ b/src/share/utf8/utf8_static.vcxproj.filters
@@ -14,26 +14,11 @@
     </Filter>
   </ItemGroup>
   <ItemGroup>
-    <ClInclude Include="charmaps.h">
-      <Filter>Header Files</Filter>
-    </ClInclude>
-    <ClInclude Include="charset.h">
-      <Filter>Header Files</Filter>
-    </ClInclude>
-    <ClInclude Include="charsetmap.h">
-      <Filter>Header Files</Filter>
-    </ClInclude>
     <ClInclude Include="..\..\..\include\share\utf8.h">
       <Filter>Public Header Files</Filter>
     </ClInclude>
   </ItemGroup>
   <ItemGroup>
-    <ClCompile Include="charset.c">
-      <Filter>Source Files</Filter>
-    </ClCompile>
-    <ClCompile Include="iconvert.c">
-      <Filter>Source Files</Filter>
-    </ClCompile>
     <ClCompile Include="utf8.c">
       <Filter>Source Files</Filter>
     </ClCompile>
